<?php
/*
 * @version $Id: hook.php 7355 2008-10-03 15:31:00Z moyo $
 ----------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copynetwork (C) 2003-2006 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org/
 ----------------------------------------------------------------------

 LICENSE

 This file is part of GLPI.

 GLPI is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 GLPI is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GLPI; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: DOMBRE Julien
// Purpose of file:
// ----------------------------------------------------------------------

foreach (glob(GLPI_ROOT . '/plugins/suppliertag/inc/*.php') as $file)
	include_once ($file);

function plugin_suppliertag_install(){
		
	include_once (GLPI_ROOT."/inc/profile.class.php");
	
	if(!TableExists("glpi_plugin_suppliertag_profiles") ){
	
		plugin_suppliertag_installing("1.2.0");
	
	}elseif(TableExists("glpi_plugin_suppliertag_config") && !FieldExists("glpi_plugin_suppliertag_config","FK_entities")) {
	
		plugin_suppliertag_update("1.1");
		plugin_suppliertag_update("1.2.0");

	}elseif(TableExists("glpi_plugin_suppliertag_profiles") && FieldExists("glpi_plugin_suppliertag_profiles","interface")) {
	
		plugin_suppliertag_update("1.2.0");

	}
	
	plugin_suppliertag_createFirstAccess($_SESSION['glpiactiveprofile']['ID']);
	return true;
}

function plugin_suppliertag_uninstall(){
	global $DB;
	
	$tables = array("glpi_plugin_suppliertag_profiles",
					"glpi_plugin_suppliertag_config",
					"glpi_plugin_suppliertag_imported");
					
	foreach($tables as $table)				
		$DB->query("DROP TABLE `$table`;");
	
	plugin_init_suppliertag();
	cleanCache("GLPI_HEADER_".$_SESSION["glpiID"]);

	return true;
}
////// SEARCH FUNCTIONS ///////(){

// Define search option for types of the plugins
function plugin_suppliertag_getSearchOption(){
	global $LANG;
	$sopt=array();
	
	if (plugin_suppliertag_haveRight("suppliertag","r")){

		//from core search
		$sopt[COMPUTER_TYPE][2150]['table']='glpi_plugin_suppliertag_models';
		$sopt[COMPUTER_TYPE][2150]['field']='FK_model';
		$sopt[COMPUTER_TYPE][2150]['linkfield']='';
		$sopt[COMPUTER_TYPE][2150]['name']=$LANG['plugin_suppliertag']['title'][1]." - ".$LANG['plugin_suppliertag']['import'][32];
		$sopt[COMPUTER_TYPE][2150]['forcegroupby']='1';
		
		$sopt[MONITOR_TYPE][2150]['table']='glpi_plugin_suppliertag_models';
		$sopt[MONITOR_TYPE][2150]['field']='FK_model';
		$sopt[MONITOR_TYPE][2150]['linkfield']='';
		$sopt[MONITOR_TYPE][2150]['name']=$LANG['plugin_suppliertag']['title'][1]." - ".$LANG['plugin_suppliertag']['import'][32];
		$sopt[MONITOR_TYPE][2150]['forcegroupby']='1';
		
		$sopt[NETWORKING_TYPE][2150]['table']='glpi_plugin_suppliertag_models';
		$sopt[NETWORKING_TYPE][2150]['field']='FK_model';
		$sopt[NETWORKING_TYPE][2150]['linkfield']='';
		$sopt[NETWORKING_TYPE][2150]['name']=$LANG['plugin_suppliertag']['title'][1]." - ".$LANG['plugin_suppliertag']['import'][32];
		$sopt[NETWORKING_TYPE][2150]['forcegroupby']='1';
		
		$sopt[PERIPHERAL_TYPE][2150]['table']='glpi_plugin_suppliertag_models';
		$sopt[PERIPHERAL_TYPE][2150]['field']='FK_model';
		$sopt[PERIPHERAL_TYPE][2150]['linkfield']='';
		$sopt[PERIPHERAL_TYPE][2150]['name']=$LANG['plugin_suppliertag']['title'][1]." - ".$LANG['plugin_suppliertag']['import'][32];
		$sopt[PERIPHERAL_TYPE][2150]['forcegroupby']='1';
		
		$sopt[PRINTER_TYPE][2150]['table']='glpi_plugin_suppliertag_models';
		$sopt[PRINTER_TYPE][2150]['field']='FK_model';
		$sopt[PRINTER_TYPE][2150]['linkfield']='';
		$sopt[PRINTER_TYPE][2150]['name']=$LANG['plugin_suppliertag']['title'][1]." - ".$LANG['plugin_suppliertag']['import'][32];
		$sopt[PRINTER_TYPE][2150]['forcegroupby']='1';

	}
	return $sopt;
}

//for search
function plugin_suppliertag_addLeftJoin($type,$ref_table,$new_table,$linkfield,&$already_link_tables){

	switch ($new_table){
		
		case "glpi_plugin_suppliertag_models" : // From items
			$out= " LEFT JOIN `glpi_plugin_suppliertag_models` ON (`$ref_table`.`ID` = `glpi_plugin_suppliertag_models`.`FK_device` AND `glpi_plugin_suppliertag_models`.`device_type` = '$type') ";
			return $out;
			break;
	}
	
	return "";
}

//force groupby for multible links to items
function plugin_suppliertag_forceGroupBy($type){

	return true;
	switch ($type){
		case PLUGIN_SUPPLIERTAG_MODEL_TYPE:
			return true;
			break;
		
	}
	return false;
}

// Hook done on delete item case

function plugin_pre_item_delete_suppliertag($input){
	if (isset($input["_item_type_"]))
		switch ($input["_item_type_"]){
			case PROFILE_TYPE :
				// Manipulate data if needed 
				$PluginSuppliertagProfile=new PluginSuppliertagProfile;
				$PluginSuppliertagProfile->cleanProfiles($input["ID"]);
				break;
		}
	return $input;
}

////// SPECIFIC MODIF MASSIVE FUNCTIONS ///////

function plugin_suppliertag_MassiveActions($type){
	global $LANG;

	if (in_array($type, plugin_suppliertag_getTypes())) {
			return array("plugin_suppliertag_add_model"=>$LANG['plugin_suppliertag']['import'][12]);
		}
	return array();
}

function plugin_suppliertag_MassiveActionsDisplay($type,$action){
	global $LANG,$CFG_GLPI;
	if (in_array($type, plugin_suppliertag_getTypes())) {
				echo "<input type=\"text\" name=\"FK_Model\">&nbsp;";
				echo "<input type=\"submit\" name=\"massiveaction\" class=\"submit\" value=\"".$LANG['buttons'][2]."\" >";
		}
	return "";
}

function plugin_suppliertag_MassiveActionsProcess($data){
	global $LANG,$DB;

	switch ($data['action']){
	
		case "plugin_suppliertag_add_model":

			$ci2=new CommonItem();
				foreach ($data["item"] as $key => $val){
					if ($val==1) {
						// Items exists ?
						if ($ci2->getFromDB($data["device_type"],$key)){
						
							plugin_suppliertag_insert_Model($key,$data['device_type'],$data['FK_Model']);
							
						}
					}
				}
		break;
	}
}

// Define headings added by the plugin
function plugin_get_headings_suppliertag($type,$ID,$withtemplate){
	global $LANG;

	if ($type==PROFILE_TYPE) {
		$prof = new Profile();
		if ($ID>0 && $prof->getFromDB($ID) && $prof->fields['interface']!='helpdesk') {
			return array(
				1 => $LANG['plugin_suppliertag']['title'][1],
				);
		} else {
			return array();			
		}
	}		
		
	if (in_array($type, plugin_suppliertag_getTypes())) {
		// template case
		if ($withtemplate) {
			return array();

		// Non template case
		} else  {
			return array(
				1 => $LANG['plugin_suppliertag']['title'][1],
				);
		}
	}
	return false;	
}

// Define headings actions added by the plugin	 
function plugin_headings_actions_suppliertag($type){

	if (in_array($type,plugin_suppliertag_getTypes()) ||
		$type==PROFILE_TYPE) {
		return array(
				1 => "plugin_headings_suppliertag",
				);
	}else
		return false;
}

// suppliertag of an action heading
function plugin_headings_suppliertag($type,$ID){
	global $CFG_GLPI,$LANG;
		
		switch ($type){
			case PROFILE_TYPE :
				$prof=new PluginSuppliertagProfile();	
				if (!$prof->GetfromDB($ID))
					plugin_suppliertag_createAccess($ID);				
				$prof->showForm($CFG_GLPI["root_doc"]."/plugins/suppliertag/front/plugin_suppliertag.profile.php",$ID);
				break;
			default :
				if (in_array($type, plugin_suppliertag_getTypes())){
					echo "<div align='center'>";
					echo plugin_suppliertag_modelNumber($type,$ID);
					echo "</div>";
				}
			break;
		}
}


?>