<?php
/*
  ----------------------------------------------------------------------
  GLPI - Gestionnaire Libre de Parc Informatique
  Copyright (C) 2003-2008 by the INDEPNET Development Team.
  
  http://indepnet.net/   http://glpi-project.org/
  ----------------------------------------------------------------------
  
  LICENSE
  
  This file is part of GLPI.
  
  GLPI is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  GLPI is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with GLPI; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: CAILLAUD Xavier
// Purpose of file:
// ----------------------------------------------------------------------

if (!defined('GLPI_ROOT')){
	die("Sorry. You can't access directly to this file");
	}

function plugin_suppliertag_checkIfConfExists($supplier)
{
	global $DB;
	
	$query = "SELECT `glpi_plugin_suppliertag_config`.* 
				FROM `glpi_plugin_suppliertag_config` ";
	$query.=" LEFT JOIN `glpi_entities` ON (`glpi_entities`.`ID` = `glpi_plugin_suppliertag_config`.`FK_entities`)"
			." WHERE `glpi_plugin_suppliertag_config`.`FK_glpi_enterprise` != '0' 
			AND `glpi_plugin_suppliertag_config`.`ID` != 4 AND `glpi_plugin_suppliertag_config`.`name` = '".$supplier."' ";
	$query.= "".getEntitiesRestrictRequest(" AND","glpi_plugin_suppliertag_config",'','',true);
	$query.= " ORDER BY `glpi_plugin_suppliertag_config`.`FK_entities` DESC";
	
	$result=$DB->query($query);
	if ($DB->numrows($result) > 0){
		while ($data=$DB->fetch_array($result)){
			$supplierID=$data["ID"];
		}

		return $supplierID;
	}else
		return false;
}

function plugin_suppliertag_addDefaultConf($supplier)
{

	$input["name"]=$supplier;
	if ($supplier=='Dell')
	$input["Supplier_url"]="http://support.dell.com/support/topics/global.aspx/support/my_systems_info/details?c=us&l=en&s=bsd&ServiceTag=";
	elseif ($supplier=='HP')
	$input["Supplier_url"]="http://www11.itrc.hp.com/service/ewarranty/warrantyResults.do?";
	elseif ($supplier=='Fujitsu-Siemens')
	$input["Supplier_url"]="http://sali.fujitsu-siemens.co.uk/ServiceEntitlement/service.asp?";
	elseif ($supplier=='IBM')
	$input["Supplier_url"]="http://www-304.ibm.com/jct01004c/systems/support/supportsite.wss/warranty?";
	elseif ($supplier=='Toshiba')
	$input["Supplier_url"]="http://toshiba.eclaim.com/toshiba/tsbclok2.asp?";
	
	$input["FK_glpi_enterprise"]=0;
	$input["FK_enterprise"]=0;
	$input["warranty"]=36;
	$input["rubrique"]=0;
	$input["FK_entities"]=$_SESSION["glpiactive_entity"];
	
	$PluginSuppliertagConfig= new PluginSuppliertagConfig();
	return $PluginSuppliertagConfig->add($input);
}

function plugin_suppliertag_checkIfModelNeeds($type,$ID)
{
		
	$obj = new PluginSuppliertagModels();
	if($obj->getFromDBbyDevice($ID,$type))
		return $obj->fields["FK_model"];
	else
		return false;
}

function plugin_suppliertag_insert_Model($ID,$type,$model){
	
	$obj = new PluginSuppliertagModels();

	if ($obj->getFromDBbyDevice($ID,$type)){

		$obj->update(array(
			'ID'=>$obj->fields['ID'],
			'FK_model'=>$model,
			'FK_device'=>$ID,
			'device_type'=>$type));
	} else {

		$obj->add(array(
			'FK_model'=>$model,
			'FK_device'=>$ID,
			'device_type'=>$type));
	}

}

function plugin_suppliertag_delete_Model($ID){
	
	$obj = new PluginSuppliertagModels();
	$obj->delete(array('ID'=>$ID));
		
}

function plugin_suppliertag_checkIfAlreadyImported($type,$ID)
{
	
	$obj = new PluginSuppliertagImported();
	if($obj->getFromDBbyDevice($ID,$type))
		return $obj->fields["ID"];
	else
		return false;
}

function plugin_suppliertag_import_reinit_once($type,$ID){

	GLOBAL $DB;
	
	$obj = new PluginSuppliertagImported();
	if($obj->getFromDBbyDevice($ID,$type)){
			
		$doc= new Document();
		if ($doc->GetfromDB($obj->fields["FK_doc"])){
		
			$query ="DELETE 
					FROM `glpi_doc_device` 
					WHERE `FK_doc` = '".$obj->fields["FK_doc"]."';";
			$result=$DB->query($query);
			
			if(is_file(GLPI_DOC_DIR."/".$doc->fields["filename"])&& !is_dir(GLPI_DOC_DIR."/".$doc->fields["filename"]))
				unlink(GLPI_DOC_DIR."/".$doc->fields["filename"]);
			
			$doc->delete(array('ID'=>$obj->fields["FK_doc"]),true);

		}	
	}
	
	$obj->delete(array('ID'=>$obj->fields["ID"]));
}

?>