<?php
/*
  ----------------------------------------------------------------------
  GLPI - Gestionnaire Libre de Parc Informatique
  Copyright (C) 2003-2008 by the INDEPNET Development Team.
  
  http://indepnet.net/   http://glpi-project.org/
  ----------------------------------------------------------------------
  
  LICENSE
  
  This file is part of GLPI.
  
  GLPI is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  GLPI is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with GLPI; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: CAILLAUD Xavier
// Purpose of file:
// ----------------------------------------------------------------------

if (!defined('GLPI_ROOT')){
	die("Sorry. You can't access directly to this file");
	}

/**
 * Prints the model add form (into devices)
 *
 * @param $device the device ID
 * @param $type the device type
 * @return nothing (print out a table)
 *
 */
function plugin_suppliertag_modelNumber ($type,$device) {
	
	GLOBAL $DB,$CFG_GLPI,$LANG;
	
	$canedit=plugin_suppliertag_haveRight("suppliertag","w") && haveTypeRight(INFOCOM_TYPE,"w");
	
	$query = "SELECT * 
				FROM `glpi_plugin_suppliertag_models` 
				WHERE `device_type` = '".$type."' 
				AND `FK_device` = '".$device."'";
	$result = $DB->query($query);
	$number = $DB->numrows($result);
	
	echo "<form method='post' action=\"".$CFG_GLPI["root_doc"]."/plugins/suppliertag/index.php\">";
	echo "<div align=\"center\"><table class=\"tab_cadre\"  cellspacing=\"2\" cellpadding=\"2\">";
	echo "<tr><th colspan='2'>".$LANG['plugin_suppliertag']['title'][1]."</th></tr>";
	echo "<tr><th colspan='2'>".$LANG['plugin_suppliertag']['import'][30]."</th></tr>";
	
	echo "<tr>";
	echo "<td class='tab_bg_2' align='left'>";
	
	if($number ==1){
		while($line=$DB->fetch_array($result)){
			$ID=$line["ID"];
			echo "<input type='text' name='FK_model' size='30' value='".$line["FK_model"]."'>";
			echo "</td>";
			if ($canedit)
			echo "<td align='center' class='tab_bg_2'><a href='".$CFG_GLPI["root_doc"]."/plugins/suppliertag/index.php?delete_model=delete_model&amp;ID=".$ID."'><b>".$LANG['buttons'][6]."</b></a></td>";
		}
		
	}elseif ($canedit){
		echo "<input type='text' name='FK_model' size='30'>";
		echo "</td>";
		echo "</tr>";
		echo "<tr><th colspan='2'><input type='hidden' name='FK_device' value='".$device."'><input type='hidden' name='device_type' value='".$type."'><input type=\"submit\" name=\"update_model\" class=\"submit\" value=\"".$LANG['buttons'][2]."\" ></th></tr>";
	}
	
	echo "</table></div>";
	echo "</form>";

}

/**
 * Prints search form
 *
 * @param $manufacturer the supplier choice
 * @param $type the device type
 * @return nothing (print out a table)
 *
 */
function plugin_suppliertag_searchForm ($type,$manufacturer,$imported) {
	global $DB,$LANG,$CFG_GLPI;
	
	echo "<form name='form' method='post' action='".$_SERVER["PHP_SELF"]."'>";
	echo "<div align='center'><table class='tab_cadre' cellpadding='5'>";
	echo "<tr><th colspan='4'>".$LANG['plugin_suppliertag']['import'][0]."</th></tr>";

	echo "<tr class='tab_bg_2'>";
	echo "<td align='center'>";
	//device choice
	$types[]=COMPUTER_TYPE;
	$types[]=NETWORKING_TYPE;
	$types[]=PRINTER_TYPE;
	$types[]=MONITOR_TYPE;
	$types[]=PERIPHERAL_TYPE;

	plugin_suppliertag_dropdownAllItems("type",0,$type,-1,$types);
	
	echo "</td><td>";
	
	//manufacturer choice AND FK_entities=(SELECT MIN(FK_entities) AS SmallestFK_entities FROM glpi_plugin_suppliertag_config)
	$query = "SELECT `glpi_plugin_suppliertag_config`.* 
				FROM `glpi_plugin_suppliertag_config` ";
	$query.=" LEFT JOIN `glpi_entities` ON (`glpi_entities`.`ID` = `glpi_plugin_suppliertag_config`.`FK_entities`)"
			." WHERE `glpi_plugin_suppliertag_config`.`FK_glpi_enterprise` != '0' 
			AND `glpi_plugin_suppliertag_config`.`ID` != 4 ";
	$query.= "".getEntitiesRestrictRequest(" AND","glpi_plugin_suppliertag_config",'','',true);
	$query.= " ORDER BY `glpi_plugin_suppliertag_config`.`FK_entities`, `glpi_plugin_suppliertag_config`.`name`";
	$result=$DB->query($query);
	$number = $DB->numrows($result);
	
	if($number !="0"){
		echo "<select name=\"manufacturer\">";
		echo "<option value=\"0\">-----</option>";

		while ($data=$DB->fetch_array($result)){
			if ($data["ID"]!=4){
				echo "<option value='".$data["ID"]."' ".($manufacturer=="".$data["ID"].""?" selected ":"").">";
				if (isMultiEntitiesMode())
					echo getdropdownname("glpi_entities",$data["FK_entities"])." > ";
				echo $data["name"];
				if (empty($data["name"]) || $_SESSION["glpiview_ID"] == 1 ){ 
					echo " (";
					echo $data["ID"].")";
					}
				echo "</option>";
			}
		}
		echo "</select>";
		echo "</td><td>";
		echo "<select name=\"imported\">";
		echo "<option value='1' ".($imported=="1"?" selected ":"").">".$LANG['plugin_suppliertag']['config'][8]."</option>";
		echo "<option value='2' ".($imported=="2"?" selected ":"").">".$LANG['plugin_suppliertag']['config'][9]."</option>";
		echo "</select>";
		
	}else{
		//please configure a supplier
		echo "<a href='".$CFG_GLPI["root_doc"]."/plugins/suppliertag/front/plugin_suppliertag.config.php'>".$LANG['plugin_suppliertag']['import'][31]."</a>";
	}

	echo "</td><td>";
	echo "<input type=\"submit\" name=\"typechoice\" class=\"submit\" value=\"".$LANG['buttons'][2]."\" >";
	
	echo "</td>";
	echo "</tr>";
	
	echo "</table></div></form>";
}

/**
 * Prints display Search Header
 *
 * @param $fixed if fixed cells
 * @param $output_type the output_type
 * @return nothing (print out a table)
 *
 */
function plugin_suppliertag_displaySearchHeader($output_type,$fixed=0){
	$out="";
	switch ($output_type){
		default :
			if ($fixed){
				$out="<div class='center'><table border='0' class='tab_cadre_fixehov'>\n";
			} else {
				$out="<div class='center'><table border='0' class='tab_cadrehov'>\n";
			}
			break;
	}
	return $out;

}

/**
 * Prints display pre import
 *
 * @param $type the type of device
 * @param $configID the ID of the supplier config
 * @param $start for pager display
 * @param $complete to see all device (already imported and not)
 * @return nothing (print out a table)
 *
 */
function plugin_suppliertag_see_PreImport ($type,$configID,$start,$imported){
	global $LANG,$DB,$LINK_ID_TABLE,$INFOFORM_PAGES,$CFG_GLPI;
	
	$modeltable = "";
	
	if ($type && $configID){
	
		$PluginSuppliertagConfig= new PluginSuppliertagConfig();
		$PluginSuppliertagConfig->GetFromDB($configID);
		$suppliername=$PluginSuppliertagConfig->fields["name"];
		$manufacturerId=$PluginSuppliertagConfig->fields["FK_glpi_enterprise"];
		
		$canedit=plugin_suppliertag_haveRight("suppliertag","w") && haveTypeRight(INFOCOM_TYPE,"w");
		
		if (!$start) {
				$start = 0;
			}
		
		//model device selection
		if ($type==COMPUTER_TYPE) {
			$modeltable = "glpi_dropdown_model";
		}elseif ($type==MONITOR_TYPE) {
			$modeltable = "glpi_dropdown_model_monitors";
		}elseif ($type==PRINTER_TYPE) {
			$modeltable = "glpi_dropdown_model_printers";
		}elseif ($type==NETWORKING_TYPE) {
			$modeltable = "glpi_dropdown_model_networking";
		}elseif ($type==PERIPHERAL_TYPE) {
			$modeltable = "glpi_dropdown_model_peripherals";
		}elseif ($type==PHONE_TYPE) {
			$modeltable = "glpi_dropdown_model_phones";
		}

		$query = "SELECT `".$LINK_ID_TABLE[$type]."`.`ID`,`".$LINK_ID_TABLE[$type]."`.`name`, `".$LINK_ID_TABLE[$type]."`.`serial`,`".$LINK_ID_TABLE[$type]."`.`FK_entities`, `glpi_plugin_suppliertag_imported`.`import_status`, `glpi_plugin_suppliertag_imported`.`FK_device`, `glpi_plugin_suppliertag_imported`.`device_type`, `glpi_plugin_suppliertag_imported`.`FK_doc`, `glpi_plugin_suppliertag_imported`.`import_date`, $type AS type,`$modeltable`.`name` AS model 
			FROM `".$LINK_ID_TABLE[$type]."` "
		." LEFT JOIN `glpi_dropdown_manufacturer` ON (`glpi_dropdown_manufacturer`.`ID` = `".$LINK_ID_TABLE[$type]."`.`FK_glpi_enterprise`)";
		
		//model device left join
		$query.= "LEFT JOIN `$modeltable` ON (`$modeltable`.`ID` = `".$LINK_ID_TABLE[$type]."`.`model`) ";
		
		$query.=" LEFT JOIN `glpi_entities` ON (`glpi_entities`.`ID` = `".$LINK_ID_TABLE[$type]."`.`FK_entities`)";
		
		$query.=" LEFT JOIN `glpi_plugin_suppliertag_imported` ON (`glpi_plugin_suppliertag_imported`.`FK_device` = `".$LINK_ID_TABLE[$type]."`.`ID` AND `glpi_plugin_suppliertag_imported`.`device_type` = '".$type."')";
		
		$query.=" LEFT JOIN `glpi_plugin_suppliertag_models` ON (`glpi_plugin_suppliertag_models`.`FK_device` = `".$LINK_ID_TABLE[$type]."`.`ID` AND `glpi_plugin_suppliertag_models`.`device_type` = '".$type."')";
		
		//serial must be not empty
		$query.= " WHERE `".$LINK_ID_TABLE[$type]."`.`deleted` = '0' 
				AND `".$LINK_ID_TABLE[$type]."`.`is_template` = '0' 
				AND `glpi_dropdown_manufacturer`.`ID` = '".$manufacturerId."' 
				AND `".$LINK_ID_TABLE[$type]."`.`serial` != '' ";
		//already imported
		if ($imported==2){
			$query.= " AND `import_status` != 2";
			if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba"){
				$query.= " AND `FK_model` is NOT NULL ";
			}
		//not imported
		}elseif ($imported==1){
			$query.= " AND (`import_date` IS NULL OR `import_status` = 2 ";
			if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba"){
				$query.= " OR `FK_model` IS NULL ";
			}
			$query.= ") ";
		}
		$query.= "".getEntitiesRestrictRequest(" AND",$LINK_ID_TABLE[$type],'','',false);
		$query.= " ORDER BY `FK_entities`,`".$LINK_ID_TABLE[$type]."`.`name`";
		
		$result = $DB->query($query);
		$numrows =  $DB->numrows($result);
		
		if ($start<$numrows) {
			
			// Set display type for export if define
			$output_type=HTML_OUTPUT;
			if (isset($_GET["display_type"])){
				$output_type=$_GET["display_type"];
			}
			$parameters="type=$type&amp;manufacturer=$configID&amp;imported=$imported";
			$total=0;
			
			if ($output_type==HTML_OUTPUT){
				plugin_suppliertag_printPager($start,$numrows,$_SERVER["PHP_SELF"],$parameters,$type);
			}
			// Define begin and end var for loop
			// Search case
			$begin_display=$start;
			$end_display=$start+$_SESSION["glpilist_limit"];
			
			// Export All case
			if (isset($_GET['export_all'])) {
				$begin_display=0;
				$end_display=$numrows;
			}
			
			if (isMultiEntitiesMode()) {
				$colsup=1;
			}else {
				$colsup=0;
			}
			//////////////////////HEADER///////////////
			if ($output_type==HTML_OUTPUT){
				echo "<form method='post' name='massiveaction_form' id='massiveaction_form' action=\"./ajax/massiveaction.php\">";
			}
			echo plugin_suppliertag_displaySearchHeader($output_type,0); //table + div
			echo "<tr><th colspan='".($canedit?(11+$colsup):(10+$colsup))."'>".$LANG['plugin_suppliertag']['import'][1]." ".$suppliername."</th></tr>";
				
			echo displaySearchNewLine($output_type);
			$header_num=1;

			echo displaySearchHeaderItem($output_type,"",$header_num);
			echo displaySearchHeaderItem($output_type,$LANG['plugin_suppliertag']['import'][2],$header_num);
			if (isMultiEntitiesMode()){
				echo displaySearchHeaderItem($output_type,$LANG['entity'][0],$header_num);
			}
			echo displaySearchHeaderItem($output_type,$LANG['plugin_suppliertag']['import'][3],$header_num);
			if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba"){
			echo displaySearchHeaderItem($output_type,$LANG['plugin_suppliertag']['import'][30],$header_num);
			}
			echo displaySearchHeaderItem($output_type,$LANG['financial'][3],$header_num);
			echo displaySearchHeaderItem($output_type,$LANG['plugin_suppliertag']['import'][26],$header_num);
			echo displaySearchHeaderItem($output_type,$LANG['plugin_suppliertag']['import'][27],$header_num);
			echo displaySearchHeaderItem($output_type,$LANG['plugin_suppliertag']['import'][4],$header_num);
			echo displaySearchHeaderItem($output_type,$LANG['plugin_suppliertag']['import'][16],$header_num);
			echo displaySearchHeaderItem($output_type,$LANG['plugin_suppliertag']['import'][21],$header_num);

			// End Line for column headers		
			echo displaySearchEndLine($output_type);
			
			$i=$start;
			if (isset($_GET['export_all']))
				$i=0;
			
			if ($i>0){
				$DB->data_seek($result,$i);
			}
			
			$row_num=1;
			
			while ($i < $numrows && $i < $end_display){
				$i++;
					
				$item_num=1;
				$line=$DB->fetch_array($result);
				$compSerial = $line['serial'];
				$compId = $line['ID'];
				$model=$line["model"];
					
				//1.show already imported items && import_status not failed
				if ($imported==2 && $line["import_status"]==1){
						
					plugin_suppliertag_selectAlreadyImported($row_num,$item_num,$line,$output_type,$configID);
				
				//2.show not imported items (with problem in import)
				}elseif ($imported==1 && $line["import_status"]==2){
					
					plugin_suppliertag_selectInFault($row_num,$item_num,$line,$output_type,$configID);
					$total+=1;
				//3.show not imported items
				}elseif($imported==1){
					
					plugin_suppliertag_selectNotImported($row_num,$item_num,$line,$output_type,$configID);
					$total+=1;
				}		
				
			}
			echo "<tr class='tab_bg_1'><td colspan='".($canedit?(11+$colsup):(10+$colsup))."'>";
			echo $LANG['plugin_suppliertag']['import'][8]." : ".$total;
			echo "</td></tr>";
		
			// Close Table
			$title="";
			// Create title
			if ($output_type==PDF_OUTPUT_PORTRAIT|| $output_type==PDF_OUTPUT_LANDSCAPE) {
				$title.=$LANG['plugin_suppliertag']['import'][1]." ".$suppliername;
			}
		
			echo displaySearchFooter($output_type,$title);

			//massive action
			if ($canedit && $output_type==HTML_OUTPUT){
				echo "<div class='center'>";
				echo "<table width='80%' class='tab_glpi'>";
				echo "<tr><td><img src=\"".$CFG_GLPI["root_doc"]."/pics/arrow-left.png\" alt=''></td><td class='center'><a onclick= \"if ( markCheckboxes('massiveaction_form') ) return false;\" href='".$_SERVER['PHP_SELF']."?select=all'>".$LANG['buttons'][18]."</a></td>";
			
				echo "<td>/</td><td class='center'><a onclick= \"if ( unMarkCheckboxes('massiveaction_form') ) return false;\" href='".$_SERVER['PHP_SELF']."?select=none'>".$LANG['buttons'][19]."</a>";
				echo "</td><td align='left' width='80%'>";
				plugin_suppliertag_dropdownMassiveAction($compId,$type,$configID,$start,$imported);
				echo "</td>";
				echo "</table>";
		
				echo "</div>";
				echo "</form>";
			}
		
			echo "<br>";
			if ($output_type==HTML_OUTPUT){
				plugin_suppliertag_printPager($start,$numrows,$_SERVER["PHP_SELF"],$parameters,$type);
			}
			
		}else{
			echo "<b>".$LANG['plugin_suppliertag']['config'][10]."</b>";
		}
	}
}

?>