<?php
/*
  ----------------------------------------------------------------------
  GLPI - Gestionnaire Libre de Parc Informatique
  Copyright (C) 2003-2008 by the INDEPNET Development Team.
  
  http://indepnet.net/   http://glpi-project.org/
  ----------------------------------------------------------------------
  
  LICENSE
  
  This file is part of GLPI.
  
  GLPI is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  GLPI is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with GLPI; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: CAILLAUD Xavier
// Purpose of file:
// ----------------------------------------------------------------------

if (!defined('GLPI_ROOT')){
	die("Sorry. You can't access directly to this file");
	}

function plugin_suppliertag_getTypes () {
	static $types = array(
		COMPUTER_TYPE,MONITOR_TYPE,NETWORKING_TYPE,PERIPHERAL_TYPE,PRINTER_TYPE
		);
	return $types;	
}

function plugin_suppliertag_dropdownAllItems($myname,$value_type=0,$value=0,$entity_restrict=-1,$types='') {
	global $LANG,$CFG_GLPI;
	if (!is_array($types)){
		$types=plugin_suppliertag_getTypes ();
	}
	$rand=mt_rand();
	$ci=new CommonItem();
	$options=array();
	
	foreach ($types as $type){
		$ci->setType($type);
		$options[$type]=$ci->getType();
	}
	asort($options);
	if (count($options)){
		echo "<select name='type' id='item_type$rand'>\n";
			echo "<option value='0'>-----</option>\n";
		foreach ($options as $key => $val){
			echo "<option value='".$key."' ".($key==$value?"selected": "").">".$val."</option>\n";
		}
		echo "</select>&nbsp;";
	}
}

function plugin_suppliertag_dropdownMassiveAction($ID,$type,$manufacturer,$start,$imported){
	global $LANG,$CFG_GLPI;

	echo "<select name=\"massiveaction\" id='massiveaction'>";
	echo "<option value=\"-1\" selected>-----</option>";
	//not imported
	if ($imported==1){
		echo "<option value=\"import\">".$LANG['plugin_suppliertag']['import'][9]."</option>";
	}
	echo "<option value=\"reinit_once\">".$LANG['plugin_suppliertag']['import'][20]."</option>";
	
	echo "</select>";

	$params=array('action'=>'__VALUE__',
			'manufacturer'=>$manufacturer,
			'type'=>$type,
			'start'=>$start,
			'imported'=>$imported,
			'ID'=>$ID,
			);
	
		ajaxUpdateItemOnSelectEvent("massiveaction","show_massiveaction",$CFG_GLPI["root_doc"]."/plugins/suppliertag/ajax/dropdownMassiveAction.php",$params);
	
	echo "<span id='show_massiveaction'>&nbsp;</span>\n";

}

?>