<?php
/*
  ----------------------------------------------------------------------
  GLPI - Gestionnaire Libre de Parc Informatique
  Copyright (C) 2003-2008 by the INDEPNET Development Team.
  
  http://indepnet.net/   http://glpi-project.org/
  ----------------------------------------------------------------------
  
  LICENSE
  
  This file is part of GLPI.
  
  GLPI is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  GLPI is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with GLPI; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: CAILLAUD Xavier
// Purpose of file:
// ----------------------------------------------------------------------

if (!defined('GLPI_ROOT')){
	die("Sorry. You can't access directly to this file");
	}

/**
 * Fonction to use the supplier url
 *
 * @param $suppliername the suppliername
 * @param $supplierUrl the supplierUrl (in plugin config)
 * @param $compSerial the serial of the device
 * @param $otherSerial the otherSerial (model) of the device
 * @return $url of the supplier
 *
 */
function plugin_suppliertag_select_Supplier ($suppliername,$supplierUrl,$compSerial,$otherSerial){
	
	if ($suppliername=="Dell"){
								
		$url = $supplierUrl.$compSerial;
	
	}elseif($suppliername=="HP"){//hp
		
		//list($otherSerial,$Serial)=explode("-",$compSerial);
		$url = $supplierUrl."productNumber=".$otherSerial."&serialNumber1=".$compSerial."&country=France&submit";
		
	}elseif($suppliername=="Fujitsu-Siemens"){//http://sali.fujitsu-siemens.co.uk/ServiceEntitlement/service.asp?snr=[SERIAL]&command=search
		
		$url = $supplierUrl."snr=".$compSerial."&command=search";
		
	}elseif($suppliername=="IBM"){//http://www-304.ibm.com/jct01004c/systems/support/supportsite.wss/warranty?type=[MODELE]&serial=[SERIAL]&brandind=5000008&Submit=Submit&action=warranty
		
		//list($otherSerial,$Serial)=explode("-",$compSerial);
		$url = $supplierUrl."type=".$otherSerial."&serial=".$compSerial."&brandind=5000008&Submit=Submit&action=warranty";
		
	}elseif($suppliername=="Toshiba"){//http://toshiba.eclaim.com/toshiba/tsbclok2.asp?SelectModel=[MODELE]&SelectSerial=[SERIAL]&pCallFrom=MAIN
	
		//list($otherSerial,$Serial)=explode("/",$compSerial);
		$url = $supplierUrl."SelectModel=".$otherSerial."&SelectSerial=".$compSerial."&pCallFrom=MAIN";
		
	}
	
	return $url;
}

/**
 * Fonction to select the search field on the website of the supplier
 *
 * @param $suppliername the suppliername
 * @return $field for date and warranty searching
 *
 */
function plugin_suppliertag_select_SupplierField ($suppliername){

		$field='';
		if ($suppliername=="Dell"){//dell
			$field = "Ship Date:";
		}elseif($suppliername=="HP"){//hp
			$field = "Start Date";
		}elseif($suppliername=="Fujitsu-Siemens"){//fujitsu-siemens
			$field = "Service Start Date";
		}elseif($suppliername=="IBM"){//ibm
			$field = "In warranty";
		}elseif($suppliername=="Toshiba"){//toshiba
			$field = "POP Date:";
		}
		
	return $field;
}

function plugin_suppliertag_selectAlreadyImported($row_num,$item_num,$line,$output_type,$configID){
	
	global $LANG,$DB,$LINK_ID_TABLE,$INFOFORM_PAGES,$CFG_GLPI;
	
	$canedit=plugin_suppliertag_haveRight("suppliertag","w") && haveTypeRight(INFOCOM_TYPE,"w");
	
	$PluginSuppliertagConfig= new PluginSuppliertagConfig();
	$PluginSuppliertagConfig->GetFromDB($configID);
	$suppliername=$PluginSuppliertagConfig->fields["name"];
	$supplierUrl=$PluginSuppliertagConfig->fields["Supplier_url"];
	$supplierId=$PluginSuppliertagConfig->fields["FK_enterprise"];
	$supplierWarranty=$PluginSuppliertagConfig->fields["warranty"];
	
	$row_num++;
					
	$otherSerial=plugin_suppliertag_checkIfModelNeeds($line["type"],$line["ID"]);
	
	echo displaySearchNewLine($output_type,$row_num%2);
	$ic = new Infocom;
	$output_check="";
	if ($canedit && $output_type==HTML_OUTPUT){
		$sel="";
		if (isset($_GET["select"])&&$_GET["select"]=="all") $sel="checked";
		$output_check="<input type='checkbox' name='item[".$line["ID"]."]' value='1' $sel>";
		if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba")
			if (!$otherSerial)
				$output_check="";
	}

	echo displaySearchItem($output_type,$output_check,$item_num,$row_num);

	$output_link="<a href='".$CFG_GLPI["root_doc"]."/".$INFOFORM_PAGES[$line["type"]]."?ID=".$line["ID"]."'>".$line["name"]."</a><br>".$line["model"];
	
	echo displaySearchItem($output_type,$output_link,$item_num,$row_num);
	if (isMultiEntitiesMode())
		echo displaySearchItem($output_type,getDropdownName("glpi_entities",$line['FK_entities']),$item_num,$row_num);	
	
	if($suppliername) {
		//On complete l url du support du fournisseur avec le modele si besoin
		$url=plugin_suppliertag_select_supplier($suppliername,$supplierUrl,$line['serial'],$otherSerial);
		
		//serial
		echo displaySearchItem($output_type,$line['serial'],$item_num,$row_num);
		
		//otherserial
		if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba"){
			$field=$otherSerial;
			if (!$otherSerial)
				$field="<span class='plugin_suppliertag_import_KO'>".$LANG['plugin_suppliertag']['import'][12]."</span>";
			echo displaySearchItem($output_type,$field,$item_num,$row_num);
		}

		//display infocoms
		$output_ic="";
		if($ic->getfromDBforDevice($line["type"],$line["ID"])){
			$output_ic.=$LANG['financial'][26].":".getdropdownname("glpi_enterprises",$ic->fields["FK_enterprise"])."<br>";
			$output_ic.=$LANG['financial'][14].":".convdate($ic->fields["buy_date"])."<br>";
			if ($ic->fields["warranty_duration"]==-1)
				$output_ic.=$LANG['financial'][15].":".$LANG['financial'][2]."<br>";
			else
				$output_ic.=$LANG['financial'][15].":".$ic->fields["warranty_duration"]." ".$LANG['financial'][57]."<br>";
			$output_ic.=$LANG['financial'][88];
			$output_ic.=getWarrantyExpir($ic->fields["buy_date"],$ic->fields["warranty_duration"]);
		}
		echo displaySearchItem($output_type,$output_ic,$item_num,$row_num);
		
		//display enterprise and warranty selection
		echo "<td>".getdropdownname("glpi_enterprises",$ic->fields["FK_enterprise"])."</td>";
		if ($ic->fields["warranty_duration"]==-1){
			echo "<td>".$LANG['financial'][2]."</td>";
		} else {
			echo "<td>".$ic->fields["warranty_duration"]."</td>";
		}
		
		
		//url to supplier
		$output_url="<a href='".$url."' target='_blank'>".$LANG['plugin_suppliertag']['import'][6]."</a>";
		echo displaySearchItem($output_type,$output_url,$item_num,$row_num);
		
		
		//status
		$output_doc="<span class='plugin_suppliertag_import_OK'>".$LANG['plugin_suppliertag']['import'][17];
		if (!empty($line["import_date"]))
			$output_doc.=" (".convdate($line["import_date"]).")";
		$output_doc.="</span>";

		echo displaySearchItem($output_type,$output_doc,$item_num,$row_num);
		
		//display associated doc
		$doc = new document();
		if ($doc->GetFromDB($line["FK_doc"]))
			echo displaySearchItem($output_type,getDocumentLink($doc->fields["filename"]),$item_num,$row_num);
		else
			echo displaySearchItem($output_type,"",$item_num,$row_num);
		
		echo displaySearchEndLine($output_type);
	}

}

function plugin_suppliertag_selectInFault($row_num,$item_num,$line,$output_type,$configID){
	
	global $LANG,$DB,$LINK_ID_TABLE,$INFOFORM_PAGES,$CFG_GLPI;
	
	$canedit=plugin_suppliertag_haveRight("suppliertag","w") && haveTypeRight(INFOCOM_TYPE,"w");
	
	$PluginSuppliertagConfig= new PluginSuppliertagConfig();
	$PluginSuppliertagConfig->GetFromDB($configID);
	$suppliername=$PluginSuppliertagConfig->fields["name"];
	$supplierUrl=$PluginSuppliertagConfig->fields["Supplier_url"];
	$supplierId=$PluginSuppliertagConfig->fields["FK_enterprise"];
	$supplierWarranty=$PluginSuppliertagConfig->fields["warranty"];
	
	$row_num++;
						
	//On complete l url du support du fournisseur avec le modele si besoin
	$otherSerial=plugin_suppliertag_checkIfModelNeeds($line["type"],$line["ID"]);
	if($suppliername) {

		echo displaySearchNewLine($output_type,$row_num%2);
		$ic = new Infocom;
		$output_check="";
		if ($canedit && $output_type==HTML_OUTPUT){
			$sel="";
			if (isset($_GET["select"])&&$_GET["select"]=="all") $sel="checked";
			$output_check="<input type='checkbox' name='item[".$line["ID"]."]' value='1' $sel>";
			if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba")
				if (!$otherSerial)
					$output_check="";
		}

		echo displaySearchItem($output_type,$output_check,$item_num,$row_num);

		$output_link="<a href='".$CFG_GLPI["root_doc"]."/".$INFOFORM_PAGES[$line["type"]]."?ID=".$line["ID"]."'>".$line["name"]."</a><br>".$line["model"];
		echo displaySearchItem($output_type,$output_link,$item_num,$row_num);
		if (isMultiEntitiesMode())
			echo displaySearchItem($output_type,getDropdownName("glpi_entities",$line['FK_entities']),$item_num,$row_num);
				
		$url=plugin_suppliertag_select_supplier($suppliername,$supplierUrl,$line["serial"],$otherSerial);
		
		echo displaySearchItem($output_type,$line["serial"],$item_num,$row_num);
		
		if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba"){
			$field=$otherSerial;
				if (!$otherSerial)
					$field="<span class='plugin_suppliertag_import_KO'>".$LANG['plugin_suppliertag']['import'][12]."</span>";
				echo displaySearchItem($output_type,$field,$item_num,$row_num);
		}
		//display infocoms
		$output_ic="";
		if($ic->getfromDBforDevice($line["type"],$line["ID"])){
			$output_ic.=$LANG['financial'][26].":".getdropdownname("glpi_enterprises",$ic->fields["FK_enterprise"])."<br>";
			$output_ic.=$LANG['financial'][14].":".convdate($ic->fields["buy_date"])."<br>";
			$output_ic.=$LANG['financial'][15].":".$ic->fields["warranty_duration"]." ".$LANG['financial'][57]."<br>";
			$output_ic.=$LANG['financial'][88];
			$output_ic.=getWarrantyExpir($ic->fields["buy_date"],$ic->fields["warranty_duration"]);
		}
		echo displaySearchItem($output_type,$output_ic,$item_num,$row_num);
		
		//display enterprise and warranty selection
		echo "<td>";
		if (isMultiEntitiesMode() && $supplierId){
			$enterprise=new Enterprise();
			$enterprise->getFromDB($supplierId);
			if($enterprise->fields["recursive"] || $enterprise->fields["FK_entities"]==$line['FK_entities'])
				dropdownValue("glpi_enterprises","to_FK_enterprise".$line["ID"],$supplierId,0,$line['FK_entities']);
			else{
				echo "<span class='plugin_suppliertag_import_KO'>".$LANG['plugin_suppliertag']['import'][7]."</span>";
				echo "<input type='hidden' name='to_FK_enterprise".$line["ID"]."' value='-1'>";
			}
		}else
			dropdownValue("glpi_enterprises","to_FK_enterprise".$line["ID"],$supplierId,0,$line['FK_entities']);
		echo "</td>";
		echo "<td>";
		dropdownInteger("to_warranty".$line["ID"],$supplierWarranty,0,120,1,array(-1=>$LANG['financial'][2]));
		echo "</td>";
		
		//supplier url
		$output_url="<a href='".$url."' target='_blank'>".$LANG['plugin_suppliertag']['import'][6]."</a>";
		echo displaySearchItem($output_type,$output_url,$item_num,$row_num);
		
		//status
		$output_doc="<span class='plugin_suppliertag_import_KO'>".$LANG['plugin_suppliertag']['import'][18];
		if (!empty($data["import_date"]))
			$output_doc.=" (".convdate($data["import_date"]).")";
		$output_doc.="</span>";
		echo displaySearchItem($output_type,$output_doc,$item_num,$row_num);
		
		//no associated doc
		echo displaySearchItem($output_type,"",$item_num,$row_num);
			
		echo displaySearchEndLine($output_type);
		
	}
}


function plugin_suppliertag_selectNotImported($row_num,$item_num,$line,$output_type,$configID){
	
	global $LANG,$DB,$LINK_ID_TABLE,$INFOFORM_PAGES,$CFG_GLPI;
	
	$canedit=plugin_suppliertag_haveRight("suppliertag","w") && haveTypeRight(INFOCOM_TYPE,"w");
	
	$PluginSuppliertagConfig= new PluginSuppliertagConfig();
	$PluginSuppliertagConfig->GetFromDB($configID);
	$suppliername=$PluginSuppliertagConfig->fields["name"];
	$supplierUrl=$PluginSuppliertagConfig->fields["Supplier_url"];
	$supplierId=$PluginSuppliertagConfig->fields["FK_enterprise"];
	$supplierWarranty=$PluginSuppliertagConfig->fields["warranty"];
	
	$row_num++;
	
	//On complete l url du support du fournisseur avec le modele si besoin
	$otherSerial=plugin_suppliertag_checkIfModelNeeds($line["type"],$line["ID"]);
	
	if($suppliername) {

		echo displaySearchNewLine($output_type,$row_num%2);
		$ic = new Infocom;
		$output_check="";
		if ($canedit && $output_type==HTML_OUTPUT){
			
			$sel="";
			if (isset($_GET["select"])&&$_GET["select"]=="all") $sel="checked";
			$output_check="<input type='checkbox' name='item[".$line["ID"]."]' value='1' $sel>";
			
			if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba")
				if (!$otherSerial)
					$output_check="";
		}

		echo displaySearchItem($output_type,$output_check,$item_num,$row_num);

		$output_link="<a href='".$CFG_GLPI["root_doc"]."/".$INFOFORM_PAGES[$line["type"]]."?ID=".$line["ID"]."'>".$line["name"]."</a><br>".$line["model"];
		echo displaySearchItem($output_type,$output_link,$item_num,$row_num);
		if (isMultiEntitiesMode()){
			echo displaySearchItem($output_type,getDropdownName("glpi_entities",$line['FK_entities']),$item_num,$row_num);
		}		
		
		$url=plugin_suppliertag_select_supplier($suppliername,$supplierUrl,$line["serial"],$otherSerial);
			
		echo displaySearchItem($output_type,$line["serial"],$item_num,$row_num);
			
		if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba"){
				$field=$otherSerial;
				if (!$otherSerial)
					$field="<span class='plugin_suppliertag_import_KO'>".$LANG['plugin_suppliertag']['import'][12]."</span>";
				echo displaySearchItem($output_type,$field,$item_num,$row_num);
			}

		//display infocoms
		$output_ic="";
		if($ic->getfromDBforDevice($line["type"],$line["ID"])){
			$output_ic.=$LANG['financial'][26].":".getdropdownname("glpi_enterprises",$ic->fields["FK_enterprise"])."<br>";
			$output_ic.=$LANG['financial'][14].":".convdate($ic->fields["buy_date"])."<br>";
			$output_ic.=$LANG['financial'][15].":".$ic->fields["warranty_duration"]." ".$LANG['financial'][57]."<br>";
			$output_ic.=$LANG['financial'][88];
			$output_ic.=getWarrantyExpir($ic->fields["buy_date"],$ic->fields["warranty_duration"]);
		}else{
				$output_ic.="";
			}
		echo displaySearchItem($output_type,$output_ic,$item_num,$row_num);
		
		//display enterprise and warranty selection
		echo "<td>";
		if (isMultiEntitiesMode() && $supplierId){
			$enterprise=new Enterprise();
			$enterprise->getFromDB($supplierId);
			if($enterprise->fields["recursive"] || $enterprise->fields["FK_entities"]==$line['FK_entities'])
				dropdownValue("glpi_enterprises","to_FK_enterprise".$line["ID"],$supplierId,0,$line['FK_entities']);
			else{
				echo "<span class='plugin_suppliertag_import_KO'>".$LANG['plugin_suppliertag']['import'][7]."</span>";
				echo "<input type='hidden' name='to_FK_enterprise".$line["ID"]."' value='-1'>";
			}
		}else
			dropdownValue("glpi_enterprises","to_FK_enterprise".$line["ID"],$supplierId,0,$line['FK_entities']);
		echo "</td>";
		echo "<td>";
		dropdownInteger("to_warranty".$line["ID"],$supplierWarranty,0,120,1,array(-1=>$LANG['financial'][2]));
		echo "</td>";
		
		//supplier url
		$output_url="<a href='".$url."' target='_blank'>".$LANG['plugin_suppliertag']['import'][6]."</a>";
		echo displaySearchItem($output_type,$output_url,$item_num,$row_num);
		
		//status
		echo displaySearchItem($output_type,$LANG['plugin_suppliertag']['import'][19],$item_num,$row_num);
		
		//no associated doc
		echo displaySearchItem($output_type,"",$item_num,$row_num);
		
		echo displaySearchEndLine($output_type);
		
	}

}

function plugin_suppliertag_supplierImportDate($suppliername,$finduhtml,$contents,$warranty){

	if ($suppliername=="Dell"){//dell
		$maDate = substr($finduhtml,49,10);
		$maDate = str_replace('/','-',$maDate);
		$maDate = str_replace('<','',$maDate);
		list($mois,$jour,$annee) = explode('-',$maDate);
		$maDate = date("Y-m-d",mktime(0,0,0,$mois,$jour,$annee));

	}elseif($suppliername=="HP"){//hp
	
		$maDate = substr($finduhtml,145,20);
		$maDate =trim($maDate);
		$maDate = str_replace(' ','-',$maDate);
		$maDate = str_replace('Jan','01',$maDate);
		$maDate = str_replace('Feb','02',$maDate);
		$maDate = str_replace('Mar','03',$maDate);
		$maDate = str_replace('Apr','04',$maDate);
		$maDate = str_replace('May','05',$maDate);
		$maDate = str_replace('Jun','06',$maDate);
		$maDate = str_replace('Jul','07',$maDate);
		$maDate = str_replace('Aug','08',$maDate);
		$maDate = str_replace('Sep','09',$maDate);
		$maDate = str_replace('Oct','10',$maDate);
		$maDate = str_replace('Nov','11',$maDate);
		$maDate = str_replace('Dec','12',$maDate);
		list($jour,$mois,$annee) = explode('-',$maDate);
		$maDate = date("Y-m-d",mktime(0,0,0,$mois,$jour,$annee));
		
	}elseif($suppliername=="Fujitsu-Siemens"){//Fujitsu : 08/09/2001
	
		$maDate = substr($finduhtml,60,10);
		$maDate = str_replace('/','-',$maDate);
		list($jour,$mois,$annee) = explode('-',$maDate);
		$maDate = date("Y-m-d",mktime(0,0,0,$mois,$jour,$annee));
		
	}elseif($suppliername=="IBM"){//IBM : 2008-09-03
	
		$maDate = substr($finduhtml,98,20);
		$maDate =trim($maDate);
		
	}elseif($suppliername=="Toshiba"){//toshiba : 6/29/04
	
		$maDate = substr($finduhtml,48,10);
		$maDate = str_replace('/','-',$maDate);
		$maDate = str_replace('<','',$maDate);
		list($mois,$jour,$annee) = explode('-',$maDate);
		$maDate = date("Y-m-d",mktime(0,0,0,$mois,$jour,$annee));
		
	}
	
	return $maDate;

}

function plugin_suppliertag_supplierImportWarranty($suppliername,$maDate,$contents,$warranty){

	if ($suppliername=="Dell" && $warranty == 0){//dell
		//
		// C. Pierron, TCS
		// Recherche automatique de la date de fin de garantie
		// (si la duree de garantie a ete parametree a zero dans
		//  l'interface utilisateur)
	  $masque='([0-9]{1,2}/[0-9]{1,2}/[0-9]{4})';
	  
	  preg_match_all ($masque, $contents, $liste_resultat);
	  $maDateFin = $maDate;
	  
	  foreach ($liste_resultat[0] as $occurence)
	  {
		$maCandidate = str_replace ('/', '-', $occurence);
		list ($mois, $jour, $annee) = explode ('-', $maCandidate);
		$maCandidate = $annee."-".$mois."-".$jour;
		
		if ( $maCandidate > $maDateFin )
		  $maDateFin = $maCandidate;
	  }
	  
	  $maDateFin = date ("Y-m-d", strtotime ($maDateFin) + 86400);
	  
	  list ($adebut, $mdebut, $jdebut) = explode ('-', $maDate);
	  list ($afin, $mfin, $jfin) = explode ('-', $maDateFin);
	  
	  $maGarantie = ($afin * 12 + $mfin) - ($adebut * 12 + $mdebut);
	  $warranty = $maGarantie;

	}elseif($suppliername=="HP" && $warranty == 0){//hp
		
		$field_fin = "End Date";
		$searchfin = stristr($contents, $field_fin);
		$maDateFin = substr($searchfin,142,20);
		
		$maDateFin =trim($maDateFin);
		$maDateFin = str_replace(' ','-',$maDateFin);
		$maDateFin = str_replace('Jan','01',$maDateFin);
		$maDateFin = str_replace('Feb','02',$maDateFin);
		$maDateFin = str_replace('Mar','03',$maDateFin);
		$maDateFin = str_replace('Apr','04',$maDateFin);
		$maDateFin = str_replace('May','05',$maDateFin);
		$maDateFin = str_replace('Jun','06',$maDateFin);
		$maDateFin = str_replace('Jul','07',$maDateFin);
		$maDateFin = str_replace('Aug','08',$maDateFin);
		$maDateFin = str_replace('Sep','09',$maDateFin);
		$maDateFin = str_replace('Oct','10',$maDateFin);
		$maDateFin = str_replace('Nov','11',$maDateFin);
		$maDateFin = str_replace('Dec','12',$maDateFin);

		list($jour,$mois,$annee) = explode('-',$maDateFin);
		$maDateFin = $annee."-".$mois."-".$jour;
	
		$maDateFin = date ("Y-m-d", strtotime ($maDateFin) + 86400);
		
		list ($adebut, $mdebut, $jdebut) = explode ('-', $maDate);
		list ($afin, $mfin, $jfin) = explode ('-', $maDateFin);
		
		$maGarantie = ($afin * 12 + $mfin) - ($adebut * 12 + $mdebut);
		
		$warranty = $maGarantie;
	}
	
	return $warranty;

}
/**
 * Prints display post import
 *
 * @param $type the type of device
 * @param $ID the ID of device
 * @param $fromsupplier selection on pre import
 * @param $fromwarranty selection on pre import
 * @param $configID ID of supplier plugin config
 * @return results of data import
 *
 */
function plugin_suppliertag_see_PostImport ($type,$ID,$fromsupplier,$fromwarranty,$configID){
	global $LANG,$DB,$LINK_ID_TABLE,$INFOFORM_PAGES,$CFG_GLPI;
	
	$PluginSuppliertagConfig= new PluginSuppliertagConfig();
	$PluginSuppliertagConfig->GetFromDB($configID);
	$manufacturerId=$PluginSuppliertagConfig->fields["FK_glpi_enterprise"];
				
	if($fromsupplier)
		$supplierId=$fromsupplier;
	else
		$supplierId=$PluginSuppliertagConfig->fields["FK_enterprise"];
		
	$suppliername=$PluginSuppliertagConfig->fields["name"];
	$supplierUrl=$PluginSuppliertagConfig->fields["Supplier_url"];
	$adddoc=$PluginSuppliertagConfig->fields["adddoc"];
	$rubrique=$PluginSuppliertagConfig->fields["rubrique"];
	$addcomments=$PluginSuppliertagConfig->fields["comments"];
	if($fromwarranty)
		$warranty=$fromwarranty;
	else
		$warranty=$PluginSuppliertagConfig->fields["warranty"];
	
	$query = "SELECT `".$LINK_ID_TABLE[$type]."`.`ID`,`".$LINK_ID_TABLE[$type]."`.`name`,`".$LINK_ID_TABLE[$type]."`.`FK_entities`, `".$LINK_ID_TABLE[$type]."`.`serial` 
				FROM `".$LINK_ID_TABLE[$type]."`, `glpi_dropdown_manufacturer` 
				WHERE `".$LINK_ID_TABLE[$type]."`.`FK_glpi_enterprise` = `glpi_dropdown_manufacturer`.`ID` 
				AND `".$LINK_ID_TABLE[$type]."`.`deleted` = '0' 
				AND `".$LINK_ID_TABLE[$type]."`.`is_template` = '0' 
				AND `glpi_dropdown_manufacturer`.`ID` = '".$manufacturerId."' 
				AND `".$LINK_ID_TABLE[$type]."`.`serial` != '' 
				AND `".$LINK_ID_TABLE[$type]."`.`ID` = '".$ID."' ";
	$query.= " ORDER BY `".$LINK_ID_TABLE[$type]."`.`name`";
	
	$result = $DB->query($query);
	

	while($line=$DB->fetch_array($result)){
		
		$compSerial = $line['serial'];
		$compId = $line['ID'];
		echo "<tr class='tab_bg_1' ><td>";
		echo "<a href='".$CFG_GLPI["root_doc"]."/".$INFOFORM_PAGES[$type]."?ID=".$compId."'>".$line["name"]."</a></td>";
		
		//On complete l url du support du fournisseur avec le modele si besoin
		$otherSerial=plugin_suppliertag_checkIfModelNeeds($type,$compId);

		$url=plugin_suppliertag_select_supplier($suppliername,$supplierUrl,$compSerial,$otherSerial);
		
		//On complete l url du support du fournisseur avec le serial
		echo "<td>".$compSerial."</td>";
		if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba")
			echo "<td>".$otherSerial."</td>";
		
		echo "<td><a href='".$url."' target='_blank'>".$LANG['plugin_suppliertag']['import'][6]."</a></td>";
		$contents = "";
		
		$msgerr="";
		
		if ($suppliername=="Toshiba"){
			if (empty($CFG_GLPI["proxy_name"])){

				if($fp = fopen($url,'rb')) {
					while (!feof($fp)) {
						$contents .= fread($fp, 8192);
					}
					fclose($fp);
				} else {
					$msgerr = $LANG['plugin_suppliertag']['import'][25];
				}
								
			} else { // Connection using proxy
			
				$proxy_fp = fsockopen($CFG_GLPI["proxy_name"], $CFG_GLPI["proxy_port"], $errno, $errstr, 1);
				if ($proxy_fp) {
					fputs($proxy_fp, "GET $url\n HTTP/1.0\r\nHost: ".$CFG_GLPI["proxy_name"]."\r\n");
					if (!empty($CFG_GLPI["proxy_user"])) {
						fputs($proxy_fp, "Proxy-Authorization: Basic " . base64_encode ($CFG_GLPI["proxy_user"].":".$CFG_GLPI["proxy_password"]) . "\r\n");    // added				
					}
					fputs($proxy_fp,"\r\n");
					while(!feof($proxy_fp)) {
						$contents.= fread($proxy_fp, 8192);
					}
					fclose($proxy_fp);
				} else {
					$msgerr = $LANG['setup'][311];
				}
				
			}
		}else{
			$contents = getURLContent($url, $msgerr);
		}
		// On extrait la date de livraison de la variable contents.
		// Methode peu academique, mais qui fonctionne qui suppose que la page du support du fournisseur ne change pas dans le temps.
		$field=plugin_suppliertag_select_supplierfield ($suppliername);
		
		if(!stristr($contents, $field) === FALSE) {
			$finduhtml = stristr($contents, $field);

			$maDate = plugin_suppliertag_supplierImportDate($suppliername,$finduhtml,$contents,$warranty);

			$warranty = plugin_suppliertag_supplierImportWarranty($suppliername,$maDate,$contents,$warranty);
			
			//warranty for life					
			if ($warranty < -120)
				$warranty=-1;
			
			//add new infocoms
			$ic= new infocom();
			if($ic->getfromDBforDevice($type,$ID)){
				//valeurs d'origine
				$buy_date=convdate($ic->fields["buy_date"]);
				$warranty_duration=$ic->fields["warranty_duration"];
				$FK_enterprise=getdropdownname("glpi_enterprises",$ic->fields["FK_enterprise"]);
				$ic_comments=$ic->fields["comments"];
				
				//nouvelles valeurs
				$input_infocom["ID"]=$ID;
				$date=date("Y-m-d");
				$input_infocom=array();
				if ($supplierId!=0)
					$input_infocom["FK_enterprise"]=$supplierId;
				$input_infocom["buy_date"]=$maDate;
				$input_infocom["warranty_duration"]=$warranty;
				$input_infocom["FK_device"]=$compId;
				$input_infocom["device_type"]=$type;
				if ($addcomments)
					$input_infocom["comments"]=$ic_comments."\n".$LANG['plugin_suppliertag']['import'][28]." ".$suppliername." ".$LANG['plugin_suppliertag']['import'][29]." (".convdate($date).")";
				
				$infocom = new infocom;
				$infocom->update($input_infocom);
					
			} else {
			
				//valeurs d'origine
				$buy_date="";
				$warranty_duration="";
				$FK_enterprise="";
				$ic_comments="";
				//nouvelles valeurs
				$date=date("Y-m-d");
				$input_infocom=array();
				if ($supplierId!=0)
					$input_infocom["FK_enterprise"]=$supplierId;
				$input_infocom["FK_device"]=$compId;
				$input_infocom["device_type"]=$type;
				$input_infocom["buy_date"]=$maDate;
				$input_infocom["warranty_duration"]=$warranty;
				if ($addcomments)
					$input_infocom["comments"]=$LANG['plugin_suppliertag']['import'][28]." ".$suppliername." ".$LANG['plugin_suppliertag']['import'][29]." (".convdate($date).")";
				
				$infocom = new infocom;
				$infocom->add($input_infocom);
				
			}

			$date=date("Y-m-d");
			//post message				
			echo "<td><span class='plugin_suppliertag_import_OK'>".$LANG['plugin_suppliertag']['import'][13]." (".convdate($date).")</span></td>";
			echo "<td>";
			echo $LANG['financial'][26]." : ".$FK_enterprise."->".getdropdownname("glpi_enterprises",$supplierId)."<br>";	
			echo $LANG['financial'][14]." : ".$buy_date."->".convdate($maDate)."<br>";
			if ($warranty_duration==-1)
				$warranty_duration=$LANG['financial'][2];
			if ($warranty==-1)
				$warranty=$LANG['financial'][2];
			echo $LANG['financial'][15]." : ".$warranty_duration."->".$warranty."<br>";
			echo "</td>";
			
			// on cree un doc dans GLPI qu'on va lier au materiel
		
			if ($adddoc!=0){
				//configure adding doc
				$path = GLPI_DOC_DIR."/HTML/";
				$time_file=date("Y-m-d-H-i");
				if ($type==COMPUTER_TYPE) $name="computer";
				elseif ($type==NETWORKING_TYPE) $name="networking";
				elseif ($type==PERIPHERAL_TYPE) $name="peripheral";
				elseif ($type==MONITOR_TYPE) $name="monitor";
				elseif ($type==PRINTER_TYPE) $name="printer";
				$filename="infocoms_".$suppliername."_".$name."_".$compId.".html";
				$filepath=$path.$filename;
			
				$input=array();
				$input["FK_entities"]=$line["FK_entities"];
				$input["name"]=addslashes("infocoms_".$suppliername."_".$name."_".$compId);
				$input["filename"]="HTML/".$filename;
				$input["rubrique"]=$rubrique;
				$input["type"]="text/html";
				$input["date_mod"]=date("Y-m-d H:i:s");
				$input["FK_users"]=$_SESSION["glpiID"];		
				
				$doc = new document;
				$newdoc=$doc->add($input);
				
				addDeviceDocument($newdoc,$type,$compId);
				
				$query_suppliertag="DELETE 
									FROM `glpi_plugin_suppliertag_imported` 
									WHERE FK_device='".$compId."' 
									AND device_type='".$type."';";
				$result_suppliertag=$DB->query($query_suppliertag);
				
				$values["FK_doc"]=$newdoc;
				
				//on enregistre				
				$fhtm=fopen($filepath,'wb');
				fwrite($fhtm,$contents);
				fclose($fhtm);
				
			}
			
			//insert base locale
			$date=date("Y-m-d");
			$values["import_status"]=1;
			$values["FK_device"]=$compId;
			$values["device_type"]=$type;
			$values["import_date"]=$date;
			$PluginSuppliertagImported = new PluginSuppliertagImported;
			$PluginSuppliertagImported->add($values);
						
			$_SESSION["glpi_plugin_suppliertag_total"]+=1;

		} else { // Failed
			$date=date("Y-m-d");
			echo "<td><span class='plugin_suppliertag_import_KO'>".$LANG['plugin_suppliertag']['import'][15]." (".convdate($date).")</span></td>";
			$query_suppliertag="DELETE 
								FROM `glpi_plugin_suppliertag_imported` 
								WHERE `FK_device` = '".$compId."' 
								AND `device_type` = '".$type."';";
			$result_suppliertag=$DB->query($query_suppliertag);
			
			//insert base locale
			$values["import_status"]=2;
			$values["FK_device"]=$compId;
			$values["device_type"]=$type;
			$values["import_date"]=$date;
			$PluginSuppliertagImported = new PluginSuppliertagImported;
			$PluginSuppliertagImported->add($values);
			
			if (!empty($content)) $msgerr=$LANG['plugin_suppliertag']['import'][25];
			echo "<td>$msgerr</td>";
		}

		echo "</tr>\n";
	}
}

?>