<?php
/*
   ----------------------------------------------------------------------
   GLPI - Gestionnaire Libre de Parc Informatique
   Copyright (C) 2003-2008 by the INDEPNET Development Team.

   http://indepnet.net/   http://glpi-project.org/
   ----------------------------------------------------------------------

   LICENSE

   This file is part of GLPI.

   GLPI is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   GLPI is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GLPI; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   ------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: CAILLAUD Xavier
// Purpose of file:
// ----------------------------------------------------------------------


if (!defined('GLPI_ROOT')){
	die("Sorry. You can't access directly to this file");
	}

class PluginSuppliertagConfig extends CommonDBTM {
	
	function __construct () {
		$this->table="glpi_plugin_suppliertag_config";
		$this->type=PLUGIN_SUPPLIERTAG_CONFIG_TYPE;
		$this->entity_assign=true;
		$this->may_be_recursive=true;
	}
	
	/**
	 * Preconfig datas for standard system
	 * @param $type type of standard system : AD 
	 *@return nothing
	 **/
	function preconfig($type){
	
		switch($type){
			case 'Dell':
			$this->fields['name']="Dell";
			$this->fields['Supplier_url']="http://support.dell.com/support/topics/global.aspx/support/my_systems_info/details?c=us&l=en&s=bsd&ServiceTag=";
			break;
			case 'HP':
			$this->fields['name']="HP";
			$this->fields['Supplier_url']="http://www11.itrc.hp.com/service/ewarranty/warrantyResults.do?";
			break;
			case 'Fujitsu-Siemens':
			$this->fields['name']="Fujitsu-Siemens";
			$this->fields['Supplier_url']="http://sali.fujitsu-siemens.co.uk/ServiceEntitlement/service.asp?";
			break;
			case 'IBM':
			$this->fields['name']="IBM";
			$this->fields['Supplier_url']="http://www-304.ibm.com/jct01004c/systems/support/supportsite.wss/warranty?";
			break;
			case 'Toshiba':
			$this->fields['name']="Toshiba";
			$this->fields['Supplier_url']="http://toshiba.eclaim.com/toshiba/tsbclok2.asp?";
			break;
			default:
			$this->post_getEmpty();
			break;
		
		}
	}
	
	function post_addItem($newID,$input) {
		global $DB;
		
		$PluginSuppliertagConfig=new PluginSuppliertagConfig();
		$PluginSuppliertagConfig->getFromDB($newID);
		
		if ($PluginSuppliertagConfig->fields["recursive"]){
			$query="DELETE FROM `glpi_plugin_suppliertag_config` 
					WHERE `name` = '".$PluginSuppliertagConfig->fields["name"]."' 
					AND `ID` != '$newID' " .
					getEntitiesRestrictRequest('AND','glpi_plugin_suppliertag_config','',getEntitySons($PluginSuppliertagConfig->fields["FK_entities"]));
					
			$result=$DB->query($query);
		}		
	}
	
	function post_updateItem($input,$updates,$history=1){
		global $DB;

		if ($this->fields["recursive"]){
			$query="DELETE FROM `glpi_plugin_suppliertag_config` 
					WHERE `name` = '".$this->fields["name"]."' 
					AND `ID` != '".$this->fields["ID"]."' " .
					getEntitiesRestrictRequest('AND','glpi_plugin_suppliertag_config','',getEntitySons($this->fields["FK_entities"]));
					
			$result=$DB->query($query);
		}
	}
	function showForm ($target,$ID,$supplier) {
	
		GLOBAL $CFG_GLPI, $LANG;
		
		if (!plugin_suppliertag_haveRight("suppliertag","r")) return false;

		$spotted = false;
		if ($ID>0){
			if($this->can($ID,'r')){
				$spotted = true;
			}
		}else{
			if($this->can(-1,'w')){
				$spotted = true;
				$this->getEmpty();
			}
			if (isset($_GET['preconfig'])){
				$this->preconfig($_GET['preconfig']);
			}
		}
				
		if ($spotted){
			
			$canedit=$this->can($ID,'w');
			$canrecu=$this->can($ID,'recursive');

			echo "<form name='form' method='post' action=\"$target\">";
			echo "<div align=\"center\"><table class=\"tab_cadre\"  cellspacing=\"2\" cellpadding=\"2\">";
			echo "<tr><th colspan='2'>".$LANG['plugin_suppliertag']['config'][6]."</th></tr>";
			
			echo "<tr>";
			echo "<td class='tab_bg_2'></td><td class='tab_bg_2' colspan='2'><a  href='$target?preconfig=$supplier'>".$LANG['ldap'][16]."</a></td>";
			echo "</tr>";
			
			echo "<tr>";
			echo "<td class='tab_bg_2' align='center'>".$LANG['common'][16]."</td>";
			echo "<td class='tab_bg_2' align='left'>";
			echo "<input type='text' name='name' size='50' value='".$this->fields["name"]."'>";
			echo "</td>";
			echo "</tr>";
				
			echo "<tr>";
			echo "<td class='tab_bg_2' align='center'>".$LANG['plugin_suppliertag']['config'][0]."</td>";
			echo "<td class='tab_bg_2' align='left'>";
			echo "<input type='text' name='Supplier_url' size='150' value='".$this->fields["Supplier_url"]."'>";
			echo "</td>";
			echo "</tr>";
			
			echo "<tr>";
			echo "<td class='tab_bg_2' align='center'>".$LANG['plugin_suppliertag']['config'][1]."</td>";
			echo "<td class='tab_bg_2' align='left'>";
			dropdownValue("glpi_dropdown_manufacturer","FK_glpi_enterprise",$this->fields["FK_glpi_enterprise"]);
			echo "</td>";
			echo "</tr>";
			
			echo "<tr>";
			echo "<td class='tab_bg_2' align='center'>".$LANG['plugin_suppliertag']['config'][2]."</td>";
			echo "<td class='tab_bg_2' align='left'>";
			dropdownValue("glpi_enterprises","FK_enterprise",$this->fields["FK_enterprise"]);
			echo "</td>";
			echo "</tr>";
			
			echo "<tr>";
			echo "<td class='tab_bg_2' align='center'>".$LANG['plugin_suppliertag']['config'][3]."</td>";
			echo "<td class='tab_bg_2' align='left'>";
			dropdownInteger("warranty",$this->fields["warranty"],0,120);
			echo "</td>";
			echo "</tr>";
			
			echo "<tr>";
			echo "<td class='tab_bg_2' align='center'>".$LANG['plugin_suppliertag']['config'][4]."</td>";
			echo "<td class='tab_bg_2' align='left'>";
			dropdownYesNo("adddoc",$this->fields["adddoc"]);
			echo "</td>";
			echo "</tr>";
			
			echo "<tr>";
			echo "<td class='tab_bg_2' align='center'>".$LANG['plugin_suppliertag']['config'][5]."</td>";
			echo "<td class='tab_bg_2' align='left'>";
			dropdownValue("glpi_dropdown_rubdocs","rubrique",$this->fields["rubrique"]);
			echo "</td>";
			echo "</tr>";
			
			echo "<tr>";
			echo "<td class='tab_bg_2' align='center'>".$LANG['plugin_suppliertag']['config'][7]."</td>";
			echo "<td class='tab_bg_2' align='left'>";
			dropdownYesNo("comments",$this->fields["comments"]);
			echo "</td>";
			echo "</tr>";
			if (isMultiEntitiesMode()){
				echo "<tr>";
				echo "<td class='tab_bg_2' align='center'>".$LANG['entity'][0]."</td>";
				echo "<td class='tab_bg_2' align='left'>";
				dropdownValue("glpi_entities", "FK_entities", $this->fields["FK_entities"]);
				echo "</td>";
				echo "</tr>";
			}else{
				echo "<input type='hidden' name='FK_entities' value='".$_SESSION["glpiactive_entity"]."'>";
			}
			
			echo "<tr>";
			echo "<td class='tab_bg_2'></td>";
			echo "<td class='tab_bg_2'>";
			if ($this->may_be_recursive && isMultiEntitiesMode()){
				echo $LANG['entity'][9].":&nbsp;";
			
				if (!$this->can($ID,'recursive')) {
					echo getYesNo($this->fields["recursive"]);
					$comment=$LANG['common'][86];
					$image="/pics/lock.png";
				} else if (!$this->canUnrecurs()) {
					echo getYesNo($this->fields["recursive"]);
					$comment=$LANG['common'][84];
					$image="/pics/lock.png";
				} else {
					dropdownYesNo("recursive",$this->fields["recursive"]);
					$comment=$LANG['common'][85];
					$image="/pics/aide.png";
				}
				$rand=mt_rand();
				echo "&nbsp;<img alt='' src='".$CFG_GLPI["root_doc"].$image."' onmouseout=\"cleanhide('comments_recursive$rand')\" onmouseover=\"cleandisplay('comments_recursive$rand')\">";
				echo "<span class='over_link' id='comments_recursive$rand'>$comment</span>";
				
			} else {
				echo "&nbsp;";
			}
			echo "</td>";
			echo "</tr>";
						
			if ($canedit) {
			
				if (empty($ID)||$ID<0){

					echo "<tr>";
					echo "<td class='tab_bg_2' valign='top' colspan='3'>";
					echo "<div align='center'><input type='submit' name='add' value=\"".$LANG['buttons'][8]."\" class='submit'></div>";
					echo "</td>";
					echo "</tr>";
		
				} else {
		
					echo "<tr>";
					echo "<td class='tab_bg_2' valign='top' colspan='3'><div align='center'>";
					echo "<input type='hidden' name='ID' value=\"$ID\">\n";
					echo "<input type='submit' name='update_config' value=\"".$LANG['buttons'][7]."\" class='submit' >";
					echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type='submit' name='delete' value=\"".$LANG['buttons'][6]."\" class='submit'></div>";
					echo "</td>";
					echo "</tr>";
		
				}
			}
			
			echo "</table></div>";
			echo "</form><br>";
		}
	}
	
}

class PluginSuppliertagModels extends CommonDBTM {

	function __construct () {
		$this->table="glpi_plugin_suppliertag_models";
		$this->type=-1;
	}
	
	function getFromDBbyDevice($FK_device,$device_type) {
		global $DB;
		$query = "SELECT * FROM `".$this->table."` " .
			"WHERE `FK_device` = '" . $FK_device . "' 
			AND `device_type` = '" . $device_type . "' ";
		if ($result = $DB->query($query)) {
			if ($DB->numrows($result) != 1) {
				return false;
			}
			$this->fields = $DB->fetch_assoc($result);
			if (is_array($this->fields) && count($this->fields)) {
				return true;
			} else {
				return false;
			}
		}
		return false;
	}
}

class PluginSuppliertagImported extends CommonDBTM {

	function __construct () {
		$this->table="glpi_plugin_suppliertag_imported";
		$this->type=-1;
	}
	
	function getFromDBbyDevice($FK_device,$device_type) {
		global $DB;
		$query = "SELECT * FROM `".$this->table."` " .
			"WHERE `FK_device` = '" . $FK_device . "' 
			AND `device_type` = '" . $device_type . "' ";
		if ($result = $DB->query($query)) {
			if ($DB->numrows($result) != 1) {
				return false;
			}
			$this->fields = $DB->fetch_assoc($result);
			if (is_array($this->fields) && count($this->fields)) {
				return true;
			} else {
				return false;
			}
		}
		return false;
	}
}

?>