<?php
/*
 ----------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copyright (C) 2003-2008 by the INDEPNET Development Team.
 
 http://indepnet.net/   http://glpi.indepnet.org
 ----------------------------------------------------------------------

 LICENSE

	This file is part of GLPI.

    GLPI is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GLPI is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GLPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ------------------------------------------------------------------------
*/

// Original Author of file: CAILLAUD Xavier
// Purpose of file:
// ----------------------------------------------------------------------

$NEEDED_ITEMS=array("computer","printer","networking","monitor","software","peripheral","phone","tracking","document","user","enterprise","contract","infocom","group");
define('GLPI_ROOT', '../..');
include (GLPI_ROOT."/inc/includes.php");

useplugin('suppliertag',true);

commonHeader($LANG['plugin_suppliertag']['title'][1],$_SERVER['PHP_SELF'],"plugins","suppliertag");

if(isset($_GET)) $tab = $_GET;
if(empty($tab) && isset($_POST)) $tab = $_POST;
if(!isset($tab["ID"])) $tab["ID"] = "";
if(!isset($tab["type"])) $tab["type"] = "";
if(!isset($tab["to_FK_enterprise"])) $tab["to_FK_enterprise"] = "";
if(!isset($tab["to_warranty"])) $tab["to_warranty"] = "";
if(!isset($tab["manufacturer"])) $tab["manufacturer"] = "";
if(!isset($tab["imported"])) $tab["imported"] = 1;
if(!isset($tab["start"])) $tab["start"] = 0;

if(plugin_suppliertag_haveRight("suppliertag","r") || haveRight("config","w")){
	
	if (isset($_POST["typechoice"])){
		plugin_suppliertag_searchForm ($_POST["type"], $_POST["manufacturer"], $_POST["imported"]);
		plugin_suppliertag_see_PreImport($_POST["type"],$_POST["manufacturer"],0,$_POST["imported"]);
	
	}elseif (isset($_POST["update_model"])){
	
		plugin_suppliertag_insert_Model($_POST["FK_device"],$_POST["device_type"],$_POST["FK_model"]);
		glpi_header($_SERVER['HTTP_REFERER']);
	
	}elseif (isset($_GET["delete_model"])){
		
		plugin_suppliertag_delete_Model($_GET["ID"]);
		glpi_header($_SERVER['HTTP_REFERER']);
	
	}elseif (isset($_GET["back"])){
		
		plugin_suppliertag_searchForm ($_GET["type"], $_GET["manufacturer"], $_GET["imported"]);	
		plugin_suppliertag_see_PreImport($_GET["type"],$_GET["manufacturer"],$_GET["start"],$_GET["imported"]);
	
	}elseif (isset($_GET["reinit"])){
	
		plugin_suppliertag_import_Reinit($_GET["type"]);
		plugin_suppliertag_searchForm ($_GET["type"], $_GET["manufacturer"], $_GET["imported"]);
		plugin_suppliertag_see_PreImport($_GET["type"],$_GET["manufacturer"],$_GET["start"],$_GET["imported"]);

	}elseif (isset($_GET["infocom"])){
		checkRight("infocom","w");
		$ic=new Infocom();
		$newID=$ic->add($_GET);
		logEvent($newID, "infocom", 4, "financial", $_SESSION["glpiname"]." ".$LANG['log'][20]);
		plugin_suppliertag_searchForm ($_GET["device_type"], $_GET["manufacturer"], $_GET["imported"]);
		plugin_suppliertag_see_PreImport($_GET["device_type"],$_GET["manufacturer"],$_GET["start"],$_GET["imported"]);
		
	}else{

		plugin_suppliertag_searchForm ($tab["type"], $tab["manufacturer"], $tab["imported"]);		
		plugin_suppliertag_see_PreImport($tab["type"],$tab["manufacturer"],$tab["start"],$tab["imported"]);
	}
}else{
	echo "<div align='center'><br><br><img src=\"".$CFG_GLPI["root_doc"]."/pics/warning.png\" alt=\"warning\"><br><br>";
	echo "<b>".$LANG['login'][5]."</b></div>";
}

commonFooter();

?>