<?php
/*
 * @version $Id: setup.php,v 1.2 2006/04/02 14:45:27 moyo Exp $
 ---------------------------------------------------------------------- 
 GLPI - Gestionnaire Libre de Parc Informatique 
 Copyright (C) 2003-2008 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-suppliertag.org/
 ----------------------------------------------------------------------

 LICENSE

 This file is part of GLPI.

 GLPI is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 GLPI is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GLPI; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: CAILLAUD Xavier
// Purpose of file:
// ----------------------------------------------------------------------

include_once ("inc/plugin_suppliertag.auth.function.php");
include_once ("inc/plugin_suppliertag.profile.class.php");

// Init the hooks of the plugins -Needed
function plugin_init_suppliertag() {
	global $PLUGIN_HOOKS,$CFG_GLPI,$LANG;
	
	$PLUGIN_HOOKS['change_profile']['suppliertag'] = 'plugin_suppliertag_changeProfile';
	
	// Params : plugin name - string type - number - attributes
	registerPluginType('suppliertag', 'PLUGIN_SUPPLIERTAG_MODEL_TYPE', 2150, array(
		'classname'  => 'PluginSuppliertagModels',
		'tablename'  => 'glpi_plugin_suppliertag_models',
		'typename'   => $LANG['plugin_suppliertag']['title'][1]
		));
	
	// Params : plugin name - string type - number - attributes
	registerPluginType('suppliertag', 'PLUGIN_SUPPLIERTAG_CONFIG_TYPE', 2151, array(
		'classname'  => 'PluginSuppliertagConfig',
		'tablename'  => 'glpi_plugin_suppliertag_config',
		'specif_entities_tables' => true,
		'recursive_type' => true
		));
		
	if (isset($_SESSION["glpiID"])){
		
		array_push($CFG_GLPI["specif_entities_tables"],"glpi_plugin_suppliertag_config");
		
		if (plugin_suppliertag_haveRight("suppliertag","r")){
			$PLUGIN_HOOKS['menu_entry']['suppliertag'] = true;
            $PLUGIN_HOOKS['submenu_entry']['suppliertag']['config'] = 'front/plugin_suppliertag.config.php'; 
            $PLUGIN_HOOKS['item_add']['suppliertag'] = 'plugin_item_add_suppliertag';
            $PLUGIN_HOOKS['pre_item_delete']['suppliertag'] = 'plugin_pre_item_delete_suppliertag';
            $PLUGIN_HOOKS['headings']['suppliertag'] = 'plugin_get_headings_suppliertag';
				$PLUGIN_HOOKS['headings_action']['suppliertag'] = 'plugin_headings_actions_suppliertag';
            $PLUGIN_HOOKS['add_css']['suppliertag']="suppliertag.css";
            $PLUGIN_HOOKS['use_massive_action']['suppliertag']=1;
            
		}
		
		// Config page
			if (plugin_suppliertag_haveRight("suppliertag","r") || haveRight("config","w"))
			$PLUGIN_HOOKS['config_page']['suppliertag'] = 'front/plugin_suppliertag.config.php';
	}
}

// Get the name and the version of the plugin - Needed
function plugin_version_suppliertag(){
	global $LANG;
	
	return array (
		'name' => $LANG['plugin_suppliertag']['title'][1],
		'version' => '1.2.1',
		'author'=>'Xavier Caillaud',
		'homepage'=>'http://glpi-project.org/wiki/doku.php?id='.substr($_SESSION["glpilanguage"],0,2).':plugins:pluginslist',
		'minGlpiVersion' => '0.72',// For compatibility / no install in version < 0.72
	);

}

// Optional : check prerequisites before install : may print errors or add to message after redirect
function plugin_suppliertag_check_prerequisites(){
	if (GLPI_VERSION>=0.72){
		return true;
	} else {
		echo "GLPI version not compatible need 0.72";
	}
}

// Uninstall process for plugin : need to return true if succeeded : may display messages or add to message after redirect
function plugin_suppliertag_check_config(){
	return true;
}

// Define rights for the plugin types
function plugin_suppliertag_haveTypeRight($type,$right){
	switch ($type){
		case PLUGIN_SUPPLIERTAG_CONFIG_TYPE :
			return plugin_suppliertag_haveRight("suppliertag",$right);
			break;
	}
}

?>